"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.TWScanFinishedStatus = exports.TWJSConnectionStatus = exports.TWEvent = exports.TWDownloadMode = exports.TWDeviceName = exports.TWConsole = exports.SupportedCapabilities = exports.ScannedFileSettings = exports.ScanSettings = exports.ScanResult = exports.PdfProtection = exports.PdfDocumentSecurityLevel = exports.DeviceInfo = void 0;
exports.twConvertBinaryStringToUint8Array = twConvertBinaryStringToUint8Array;
function _classPrivateMethodInitSpec(obj, privateSet) { _checkPrivateRedeclaration(obj, privateSet); privateSet.add(obj); }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _classPrivateFieldInitSpec(obj, privateMap, value) { _checkPrivateRedeclaration(obj, privateMap); privateMap.set(obj, value); }
function _checkPrivateRedeclaration(obj, privateCollection) { if (privateCollection.has(obj)) { throw new TypeError("Cannot initialize the same private elements twice on an object"); } }
function _classPrivateFieldSet(receiver, privateMap, value) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "set"); _classApplyDescriptorSet(receiver, descriptor, value); return value; }
function _classApplyDescriptorSet(receiver, descriptor, value) { if (descriptor.set) { descriptor.set.call(receiver, value); } else { if (!descriptor.writable) { throw new TypeError("attempted to set read only private field"); } descriptor.value = value; } }
function _classPrivateMethodGet(receiver, privateSet, fn) { if (!privateSet.has(receiver)) { throw new TypeError("attempted to get private field on non-instance"); } return fn; }
function _classPrivateFieldGet(receiver, privateMap) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "get"); return _classApplyDescriptorGet(receiver, descriptor); }
function _classExtractFieldDescriptor(receiver, privateMap, action) { if (!privateMap.has(receiver)) { throw new TypeError("attempted to " + action + " private field on non-instance"); } return privateMap.get(receiver); }
function _classApplyDescriptorGet(receiver, descriptor) { if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0); } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i["return"] && (_r = _i["return"](), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e2) { throw _e2; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e3) { didErr = true; err = _e3; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
/**
 * Enum for TWAIN JS Connection Status.
 * @enum {object}
 */
var TWJSConnectionStatus = {
  /**
   * Connection is in progress.
   */
  CONNECTING: {
    value: 0,
    name: "CONNECTING"
  },
  /**
   * Connection is established.
   */
  CONNECTED: {
    value: 1,
    name: "CONNECTED"
  },
  /**
   * Connection is in closing state.
   */
  CLOSING: {
    value: 2,
    name: "CLOSING"
  },
  /**
   * Connection is closed.
   */
  CLOSED: {
    value: 3,
    name: "CLOSED"
  },
  /**
   * Connection is in error state.
   */
  ERROR: {
    value: 4,
    name: "ERROR"
  }
};

/**
 * Enum for TWDeviceName.
 * @enum {string}
 */
exports.TWJSConnectionStatus = TWJSConnectionStatus;
var TWDeviceName = {
  /**
   * Current default device name will be used.
   */
  DEFAULT: "",
  /**
   * User will be prompted to select a device.
   */
  SELECT_FROM_UI: "SelectFromUI"
};

/**
 * Enum for scan finished status.
 * @enum {string}
 */
exports.TWDeviceName = TWDeviceName;
var TWScanFinishedStatus = {
  /**
   * Scan finished successfully.
   */
  SUCCESS: "success",
  /**
   * Scan was cancelled.
   */
  CANCELLED: "cancelled",
  /**
   * Scan failed.
   */
  ERROR: "error"
};

/**
 * Enum for PDF Protection encryption level.
 * @enum {number}
 */
exports.TWScanFinishedStatus = TWScanFinishedStatus;
var PdfDocumentSecurityLevel = {
  /**
   * No encryption.
   */
  NONE: 0,
  /**
   * 40 bit encryption.
   */
  ENCRYPTED_40BIT: 1,
  /**
   * 128 bit encryption.
   */
  ENCRYPTED_128BIT: 2
};

/**
 * Basic TWTWainJSInfo information.
 */
exports.PdfDocumentSecurityLevel = PdfDocumentSecurityLevel;
var TWTwainJSInfo = /*#__PURE__*/_createClass(
/**
 * Creates an instance of TWTwainJSInfo.
 * @param {String} name
 * @param {Number} port
 * @param {String} id
 * @param {String} clientVersion
 */
function TWTwainJSInfo(name, port, id, clientVersion) {
  _classCallCheck(this, TWTwainJSInfo);
  /**
   * Name of the TWTwainJS instance.
   * @member {String}
   */
  this.name = name;

  /**
   * Port of the TWTwainJS instance.
   * @member {Number}
   */
  this.port = port;

  /**
   * Id of the TWTwainJS instance.
   * @member {String} */
  this.id = id;

  /**
   * Client version. Useful for debugging.
   * @member {String} */
  this.clientVersion = clientVersion;

  /**
   * Library version. Usefull for debugging.
   * @member {String}
   */
  this.libraryVersion = "1.0.1.0";
});
var TWSendMessageType = {
  GET_DEVICE_LIST: "getDeviceList",
  GET_DEVICE_INFO: "getDeviceInfo",
  GET_CURRENT_SETTINGS: "getCurrentSettings",
  SCAN: "scan",
  INIT_CONFIG: "initConfig",
  GET_FILE_DOWNLOAD: "getFileDownload",
  GET_FILE: "getFile"
};
var TWReceiveMessageType = {
  DEVICE_LIST_RETRIEVED: "twDeviceListRetrieved",
  DEVICE_INFO_RETRIEVED: "twDeviceInfoRetrieved",
  CURRENT_SETTINGS_RECEIVED: "twCurrentSettingsReceived",
  PAGE_SCANNED: "twPageScanned",
  SCAN_FINISHED: "twScanFinished",
  TW_ERROR: "twErrorOccurred",
  TW_WELCOME: "twWelcome",
  TW_INIT_CONFIG: "twInitConfigResult",
  SINGLE_FILE_DOWNLOADED: "twSingleFileDownloaded",
  DOWNLOAD_FINISHED: "twDownloadFinished",
  SINGLE_FILE_RETRIEVED: "twSingleFileRetrieved",
  FILE_RETRIEVE_FINISHED: "twFileRetrieveFinished"
};

/**
 * Enum for TW TWAIN JS Events.
 * @enum {string}
 */
var TWEvent = {
  /**
   * Connection status changes.
   */
  SOCKET_CONNECTION_STATUS_CHANGED: "twSocketConnectionStatusChanged",
  /**
   * Device list is retrieved.
   */
  DEVICE_LIST_RETRIEVED: "twScannerListRetrieved",
  /**
   * Device info is retrieved.
   */
  DEVICE_INFO_RETRIEVED: "twDeviceInfoRetrieved",
  /**
   * Current settings are retrieved.
   */
  CURRENT_SETTINGS_RECEIVED: "twCurrentSettingsReceived",
  /**
   * Page is scanned.
   */
  PAGE_SCANNED: "twPageScanned",
  /**
   * Scan has finished.
   */
  SCAN_FINISHED: "twScanFinished",
  /**
   * Error occurred.
   */
  TW_ERROR: "twErrorOccurred",
  /**
   * Single file has been downloaded.
   */
  SINGLE_FILE_DOWNLOADED: "twSingleFileDownloaded",
  /**
   * Download has finished.
   */
  DOWNLOAD_FINISHED: "twDownloadFinished",
  /**
   * Single file has been retrieved.
   */
  SINGLE_FILE_RETRIEVED: "twSingleFileRetrieved",
  /**
   * Retrieve of file(s) has finished.
   */
  FILE_RETRIEVE_FINISHED: "twFileRetrieveFinished"
};

/**
 * Enum for TWAIN JS Download Mode.
 * @enum {string}
 */
exports.TWEvent = TWEvent;
var TWDownloadMode = {
  /**
   * File will be downloaded to the client in the location specified by the client settings.
   */
  LOCAL: "local",
  /**
   * File will be downloaded using the standard browser download dialog.
   */
  STANDARD: "standard"
};
exports.TWDownloadMode = TWDownloadMode;
var TWConsole = {
  EVENT: "twainJs_logTWEvent",
  SENT_MSG: "twainJs_logTWSentMsg",
  RECEIVED_MSG: "twainJs_logTWReceivedMsg"
};

/**
 * Converts a base64 encoded binary string to a Uint8Array.
 * @param {String} binaryString - base64 encoded string
 * @returns {Uint8Array}
 */
exports.TWConsole = TWConsole;
function twConvertBinaryStringToUint8Array(binaryString) {
  var input = atob(binaryString);
  var sliceSize = 512;
  var bytes = [];
  for (var offset = 0; offset < input.length; offset += sliceSize) {
    var slice = input.slice(offset, offset + sliceSize);
    var byteNumbers = new Array(slice.length);
    for (var i = 0; i < slice.length; i++) {
      byteNumbers[i] = slice.charCodeAt(i);
    }
    var byteArray = new Uint8Array(byteNumbers);
    bytes.push(byteArray);
  }
  return bytes;
}

// #region helper methods
function generateUUID() {
  // Public Domain/MIT
  var d = new Date().getTime(); //Timestamp
  var d2 = typeof performance !== "undefined" && performance.now && performance.now() * 1000 || 0; //Time in microseconds since page-load or 0 if unsupported
  return "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g, function (c) {
    var r = Math.random() * 16; //random number between 0 and 16
    if (d > 0) {
      //Use timestamp until depleted
      r = (d + r) % 16 | 0;
      d = Math.floor(d / 16);
    } else {
      //Use microseconds since page-load if supported
      r = (d2 + r) % 16 | 0;
      d2 = Math.floor(d2 / 16);
    }
    return (c === "x" ? r : r & 0x3 | 0x8).toString(16);
  });
}
function addPageWarning(warning, pageNumber) {
  if (!warning) return "Invalid page number detected: " + pageNumber;else return warning + "," + pageNumber;
}
function getFileName(fileName, pageNumber) {
  if (pageNumber) {
    var fileType = getFileType(fileName);
    var fileNameWithoutFileType = fileName.slice(0, -fileType.length - 1);
    return fileNameWithoutFileType + "_" + pageNumber + "." + fileType;
  } else {
    return fileName;
  }
}
function getFileType(fileName) {
  var fileType = fileName.toLowerCase().slice(-4);
  if (fileType.startsWith(".")) {
    fileType = fileType.slice(1);
  }
  return fileType;
}
function getPageNumbers(pages) {
  var numbers = [];
  if (!pages) {
    return numbers;
  }
  var _iterator = _createForOfIteratorHelper(pages.match(/[0-9]+(?:\-[0-9]+)?/g)),
    _step;
  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var match = _step.value;
      if (match.includes("-")) {
        var _match$split = match.split("-"),
          _match$split2 = _slicedToArray(_match$split, 2),
          begin = _match$split2[0],
          end = _match$split2[1];
        for (var num = parseInt(begin); num <= parseInt(end); num++) {
          numbers.push(num);
        }
      } else {
        numbers.push(parseInt(match));
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
  return numbers;
}
function downloadFileUsingAnchorElement(contentAsBase64Str, fileName) {
  function downloadPdfFileUsingAnchorElement(contentAsBase64Str, fileName) {
    var binUint8Array = twConvertBinaryStringToUint8Array(contentAsBase64Str);
    var blobFile = new Blob(binUint8Array, {
      type: "application/pdf"
    });
    var fileURL = URL.createObjectURL(blobFile);
    var anchor = document.createElement("a");
    anchor.href = fileURL;
    anchor.download = fileName;
    document.body.appendChild(anchor);
    anchor.click();
    document.body.removeChild(anchor);
    URL.revokeObjectURL(fileURL);
  }
  function downloadImageFileUsingAnchorElement(contentAsBase64Str, fileName) {
    var fileType = getFileType(fileName);
    var imgType = ["jpeg", "jpg"].indexOf(fileType) > -1 ? "jpeg" : fileType;
    var fileUrl = "data:image/" + imgType + ";base64," + contentAsBase64Str;
    var anchor = document.createElement("a");
    anchor.href = fileUrl;
    anchor.download = fileName;
    document.body.appendChild(anchor);
    anchor.click();
    document.body.removeChild(anchor);
  }
  var fileType = getFileType(fileName);
  if (fileType == "pdf") {
    downloadPdfFileUsingAnchorElement(contentAsBase64Str, fileName);
  } else {
    downloadImageFileUsingAnchorElement(contentAsBase64Str, fileName);
  }
}
// #endregion

/**
 * PdfProtection class is used to set the security level of the pdf file.
 */
var PdfProtection = /*#__PURE__*/_createClass(
/**
 * Creates an instance of PdfProtection. PdfProtection class is used to set the security level of the pdf file.
 */
function PdfProtection() {
  _classCallCheck(this, PdfProtection);
  /**
   * The owner password of the pdf file.
   * @member {String}
   */
  this.ownerPassword = "";

  /**
   * The user password of the pdf file.
   * @member {String}
   */
  this.userPassword = "";

  /**
   * The security level of the pdf file.
   * @member {PdfDocumentSecurityLevel}
   * @default PdfDocumentSecurityLevel.ENCRYPTED_128BIT
   */
  this.securityLevel = PdfDocumentSecurityLevel.ENCRYPTED_128BIT;

  /**
   * Permits extracting content for accessibility purposes from the PDF document after scanning.
   * @member {Boolean}
   * @default true
   * @remarks This property is only available for PdfDocumentSecurityLevel.ENCRYPTED_128BIT;
   */
  this.permitAccessibilityExtractContent = true;

  /**
   * Permits adding annotations to the PDF document after scanning.
   * @member {Boolean}
   * @default true
   */
  this.permitAnnotations = true;

  /**
   * Permits assembling the PDF document after scanning.
   * @member {Boolean}
   * @default true
   * @remarks This property is only available for PdfDocumentSecurityLevel.ENCRYPTED_128BIT;
   */
  this.permitAssembleDocument = true;

  /**
   * Permits extracting content from the PDF document after scanning.
   * @member {Boolean}
   * @default true
   */
  this.permitExtractContent = true;

  /**
   * Permits filling in form fields in the PDF document after scanning.
   * @member {Boolean}
   * @default true
   * @remarks This property is only available for PdfDocumentSecurityLevel.ENCRYPTED_128BIT;
   */
  this.permitFormsFill = true;

  /**
   * Permits printing the PDF document in full quality after scanning.
   * @member {Boolean}
   * @default true
   * @remarks This property is only available for PdfDocumentSecurityLevel.ENCRYPTED_128BIT;
   */
  this.permitFullQualityPrint = true;

  /**
   * Permits modifying the PDF document after scanning.
   * @member {Boolean}
   * @default true
   */
  this.permitModifyDocument = true;

  /**
   * Permits printing the PDF document after scanning.
   * @member {Boolean}
   * @default true
   */
  this.permitPrint = true;
});
/**
 * SupportedCapabilities class contains the supported capabilities of the scanner.
 */
exports.PdfProtection = PdfProtection;
var SupportedCapabilities = /*#__PURE__*/function () {
  /**
   * Creates an instance of SupportedCapabilities.
   * @param {Object} capabilities The supported capabilities of the scanner.
   */
  function SupportedCapabilities(capabilities) {
    _classCallCheck(this, SupportedCapabilities);
    this.capabilities = capabilities;
  }

  /**
   * Checks if the supportedCapabilities is set.
   * @returns true if the supportedCapabilities is set, false otherwise.
   */
  _createClass(SupportedCapabilities, [{
    key: "isSet",
    value: function isSet() {
      return this.capabilities !== undefined;
    }

    /**
     * Get the capability.
     * Capability has the following properties: values, type, isReadOnly, isEnum, isMultiVal.
     * @param {string} capName capability name
     * @returns capability if available, otherwise returns undefined.
     */
  }, {
    key: "getCapability",
    value: function getCapability(capName) {
      return this.capabilities[capName];
    }

    /**
     * Check if device supports capability. If the supportedCapabilities is not set, it will display warning and return false.
     * @param {string} capName capability name
     * @returns true if the capability is supported, false otherwise.
     */
  }, {
    key: "hasCapability",
    value: function hasCapability(capName) {
      if (!this.isSet()) {
        console.warn("Supported capabilities is not set so I can't check if it has the capability " + capName);
        return false;
      }
      return this.getCapability(capName) !== undefined;
    }

    /**
     * Checks if the capability is read only. If the supportedCapabilities is not set, it will display warning and return false.
     * @param {string} capName capability name
     * @returns true if the capability is read only, false otherwise.
     */
  }, {
    key: "isReadOnly",
    value: function isReadOnly(capName) {
      if (!this.isSet()) {
        console.warn("Supported capabilities is not set so I can't check if the capability " + capName + " is read only");
        return false;
      }
      if (!this.hasCapability(capName)) {
        console.warn("Capability is not supported.");
        return true;
      }
      return this.getCapability(capName).isReadOnly;
    }

    /**
     * Checks if the value is supported for the capability.
     * If the supportedCapabilities is not set, it will display warning and return false.
     * @param {string} capName capability name
     * @param {*} value
     * @returns true if the value is supported, false otherwise.
     */
  }, {
    key: "isSupportedValue",
    value: function isSupportedValue(capName, value) {
      if (!this.isSet()) {
        console.warn("Supported capabilities is not set so I can't check if the capability " + capName + " supports the defined value ");
        return false;
      }
      if (this.hasCapability(capName)) {
        var cap = this.getCapability(capName);
        for (var i = 0; i < cap.values.length; i++) {
          var capVal = cap.isEnum ? cap.values[i].value : cap.values[i];
          if (capVal == value) {
            return true;
          }
        }
        console.log(this.getCapability(capName), value);
      }
      return false;
    }
  }]);
  return SupportedCapabilities;
}();
/**
 * Contains the settings for the downloaded file or the file to be saved/retrieved.
 */
exports.SupportedCapabilities = SupportedCapabilities;
var ScannedFileSettings = /*#__PURE__*/_createClass(
/**
 * Creates an instance of ScannedFileSettings.
 */
function ScannedFileSettings() {
  _classCallCheck(this, ScannedFileSettings);
  /**
   * The name of the file. From its extension, the file type will be determined.
   * It is mandatory field.
   * @member {String}
   * @default "TWTwainJSDownloadedFile.pdf"
   */
  this.fileName = "TWTwainJSDownloadedFile.pdf";

  /**
   * The pages to be included in generated file. If not set, all pages will be used. Example: "1-3,5,7-10".
   * Invalid values are ignored.
   * @member {String}
   */
  this.pages = "";

  /**
   * Whether to create the file as multi-page file or not. If true, the file will be created as multi-page file.
   * Only PDF and TIFF files can be multi-page files.
   * @member {Boolean}
   * @default false
   */
  this.isMultiPageFile = false;

  /**
   * The pdf protection settings. Ignored if the file type is not PDF.
   * If not set, pdf protection will be determined by the TWTwainClient app.
   * @member {PdfProtection}
   */
  this.pdfProtection = null;

  /**
   * The quality of the image file. Ignored if the file type is not JPEG or PDF.
   * If the value is NOT_SET (-1), image quality will be determined by the TWTwainClient app.
   * @member {Number}
   */
  this.imageQuality = -1;

  /**
   * The compression of the created TIFF file. Ignored if the file type is not TIFF.
   * If the value is TiffCompression.NOT_SET, tiff compression will be determined by the TWTwainClient app.
   * @member {TiffCompression}
   */
  this.tiffCompression = -1;
});
/**
 * DeviceInfo contains the device name, the supported capabilities and the current settings of the scan device.
 */
exports.ScannedFileSettings = ScannedFileSettings;
var DeviceInfo = /*#__PURE__*/_createClass(
/**
 * Creates an instance of DeviceInfo.
 * @param {String} deviceName - The name of the scan device.
 * @param {Object} supportedCapabilities - The supported capabilities of the scanner.
 * @param {Object} currentSettings - The current settings of the scanner.
 */
function DeviceInfo(deviceName, supportedCapabilities, currentSettings) {
  _classCallCheck(this, DeviceInfo);
  /**
   * The name of the scan device.
   * @member {String}
   */
  this.deviceName = deviceName;

  /**
   * The supported capabilities of the scanner.
   * @member {SupportedCapabilities}
   */
  this.supportedCapabilities = new SupportedCapabilities(supportedCapabilities);

  /**
   * The current settings of the scanner.
   * @member {Object}
   */
  this.currentSettings = currentSettings;
});
/**
 * ScanResult is the result of the last scan operation.
 * It contains the scanned page images, the image type, and the tiff file or pdf file if the image type is tiff or pdf.
 */
exports.DeviceInfo = DeviceInfo;
var ScanResult = /*#__PURE__*/function () {
  /**
   * @param {Array} images - An array of base64 encoded scanned page images.
   * @param {String} scanFormatType - The type of the scan. Can be jpeg, bmp, png, pdf or tiff.
   * @param {String} tiffFile - The base64 encoded tiff file. Only available if scanFormatType is tiff.
   * @param {String} pdfFile - The base64 encoded pdf file. Only available if scanFormatType is pdf.
   * @param {String} imageType - The type of the single image. Can be jpeg, bmp or png.
   */
  function ScanResult(images, scanFormatType, tiffFile, pdfFile) {
    _classCallCheck(this, ScanResult);
    /**
     * An array of base64 encoded scanned page images.
     * @member {Array}
     */
    this.images = images;

    /**
     * The scan format type. Can be jpeg, bmp, png, pdf or tiff.
     * @member {String}
     */
    this.scanFormatType = scanFormatType;

    /**
     * The base64 encoded tiff file. Only available if scanFormatType is tiff.
     * @member {String}
     */
    this.tiffFile = tiffFile;

    /**
     * The base64 encoded pdf file. Only available if scanFormatType is pdf.
     * @member {String}
     */
    this.pdfFile = pdfFile;

    /**
     * The type of the single image.
     * For scanFormatType = 'tiff','pdf' or 'jpeg' it is jpeg.
     * For 'bmp' it is 'bmp'.
     * For 'png' it is 'png'.
     * @member {String}
     */
    this.imageType = ["pdf", "tiff", "jpeg"].indexOf(scanFormatType) > -1 ? "jpeg" : scanFormatType;
  }

  /**
   * @returns {Number} The number of pages in the scan result.
   */
  _createClass(ScanResult, [{
    key: "pageCount",
    value: function pageCount() {
      return this.images.length;
    }

    /**
     * Get image data source URL for selected page number.
     * Useful for displaying the image in an canvas or img element.
     * @param {Number} pageNumber - The page number to get the image data from.
     * @returns {String} Data source URL with the base64 encoded image data.
     */
  }, {
    key: "getImageDataSrc",
    value: function getImageDataSrc(pageNumber) {
      if (pageNumber === undefined) pageNumber = 1;
      if (pageNumber < 1 || pageNumber > this.pageCount()) {
        throw new RangeError("Page number out of range");
      }
      var image = this.images[pageNumber - 1];
      return "data:image/" + this.imageType + ";base64," + image;
    }

    /**
     * Get image as Uint8Array for selected page number.
     * @param {Number} pageNumber - The page number to get the image data from.
     * @returns {Uint8Array} The image bytes
     */
  }, {
    key: "getImageDataAsUint8Array",
    value: function getImageDataAsUint8Array(pageNumber) {
      if (pageNumber === undefined) pageNumber = 1;
      if (pageNumber < 1 || pageNumber > this.pageCount()) {
        throw new RangeError("Page number out of range");
      }
      var binUint8Array = twConvertBinaryStringToUint8Array(this.images[pageNumber - 1]);
      return binUint8Array;
    }
  }]);
  return ScanResult;
}();
/**
 * ScanSettings object used for scanning.
 */
exports.ScanResult = ScanResult;
var ScanSettings = /*#__PURE__*/function () {
  /** Creates an instance of ScanSettings.
   * @param {string} deviceName. The name of the device to be used for scanning. If not set, the default device will be used.
   * @param {*} supportedCapabilities. Optional. If set, when the setCap is called, it will be used to check if the capability is
   * supported, read only and has supported value.
   */
  function ScanSettings() {
    var deviceName = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : TWDeviceName.DEFAULT;
    var supportedCapabilities = arguments.length > 1 ? arguments[1] : undefined;
    _classCallCheck(this, ScanSettings);
    /**
     * The scan format type to be used for scanning. If not set, the default format (jpeg) will be used.
     * If scanFormatType is set to "pdf" or "tiff":
     * - for single page image (TWEvent.PAGE_SCANNED) jpeg will be used.
     * - in TWEVent.SCAN_FINISHED, the pdf or tiff file will be returned.
     * @member {string}
     * @default "jpeg"
     */
    this.scanFormatType = "jpeg";

    /**
     * The name of the device to be used for scanning. If not set, the default device will be used.
     * @member {string}
     * @default TWDeviceName.DEFAULT
     */
    this.deviceName = deviceName;

    /**
     * The image quality to be used for scanning. If not set, the default quality will be used.
     * It has effect only if scanFormatType is set to "jpeg" or "pdf".
     * @member {number}
     * @default 80
     */
    this.imageQuality = 80;

    /**
     * Show device driver's user interface. If not set, the default value will be used.
     * @member {boolean}
     * @default true
     */
    this.showUI = true;

    /**
     * Close device driver's user interface after scanning. If not set, the default value will be used.
     * @member {boolean}
     * @default true
     */
    this.closeUIAfterAcquire = true;

    /**
     * Capabilities to be used for scanning. If not set, the default capabilities will be used.
     * It is a array of objects with the capability name and its value.
     * Recommeded is to use the setCap method to set the capabilities.
     * @member {object}
     */
    this.caps = [];

    /**
     * Supported capabilities. If set, when the setCap is called, it will be used to check if the capability is
     * supported, read only and has supported value. If not set, the setCap will not check anything and presume that the value is correct.
     * If the value is not supported, it will be ignored by the device driver.
     * @member {object}
     */
    this.supportedCapabilities = new SupportedCapabilities(supportedCapabilities);

    /**
     * The tiff compression to be used for scanning.
     * @member {CapEnum.TiffCompression}
     * @default CapEnum.TiffCompression.LZW
     */
    this.tiffCompression = 4; // CapEnum.TiffCompression.LZW

    /**
     * The pdf protection to be used for scanning. If not set, PDF will not be protected.
     * @member {PdfProtection}
     */
    this.pdfProtection = null;
  }

  /**
   * Reset scan capabilities.
   */
  _createClass(ScanSettings, [{
    key: "clearCaps",
    value: function clearCaps() {
      this.caps = [];
    }

    /**
     * Set value to the capability.
     * @param {string} capName - Name of the capability to set.
     * @param {*} capValue - The value to set.
     */
  }, {
    key: "setCap",
    value: function setCap(capName, capValue) {
      if (this.supportedCapabilities.isSet()) {
        if (!this.supportedCapabilities.hasCapability(capName)) {
          console.warn("The capability " + capName + " is not supported.");
        }
        if (this.supportedCapabilities.isReadOnly(capName)) {
          console.warn("Capability " + capName + " is read only.");
        }
        if (!this.supportedCapabilities.isSupportedValue(capName, capValue)) {
          console.warn("The value " + capValue + " is not supported for the capability " + capName);
        }
      }
      for (var cap in this._caps) {
        if (cap.name === capName) {
          cap.value = capValue;
          return;
        }
      }
      this.caps.push({
        name: capName,
        value: capValue
      });
    }
  }]);
  return ScanSettings;
}();
/**
 * Main class for the TWTwainJS library.
 */
exports.ScanSettings = ScanSettings;
var _currentSocket = /*#__PURE__*/new WeakMap();
var _twConsole = /*#__PURE__*/new WeakMap();
var _promiseEventList = /*#__PURE__*/new WeakMap();
var _toPort = /*#__PURE__*/new WeakMap();
var _key = /*#__PURE__*/new WeakMap();
var _companyName = /*#__PURE__*/new WeakMap();
var _initConfig = /*#__PURE__*/new WeakSet();
var _setTWInterval = /*#__PURE__*/new WeakSet();
var _dispatchEvent = /*#__PURE__*/new WeakSet();
var _triggerTWError = /*#__PURE__*/new WeakSet();
var _setSocket = /*#__PURE__*/new WeakSet();
var _getValidSocket = /*#__PURE__*/new WeakSet();
var _sendMessage = /*#__PURE__*/new WeakMap();
var _triggerSingleFileDownloadEvent = /*#__PURE__*/new WeakSet();
var _triggerDownloadFinishedEvent = /*#__PURE__*/new WeakSet();
var _triggerSingleFileRetrievedEvent = /*#__PURE__*/new WeakSet();
var _triggerFileRetrieveFinishedEvent = /*#__PURE__*/new WeakSet();
var TWTwainJS = /*#__PURE__*/function () {
  // #region Private fields

  //#endregion

  /**
   * The name of the TWTwainJS instance.
   * @member {string}
   */

  /**
   * The result of the last scan.
   * @member {ScanResult}
   */

  /**
   * The port used for the socket communication. It is set automatically when the connect method succeeds.
   * @member {number}
   */

  /**
   * The id of the twTwainJS instance. It is set automatically when the connect method succeeds.
   * @member {string}
   */

  /**
   * Basic information about the twTwainJS instance.
   * @member {TWTwainJSInfo}
   */

  // #region Private Methods

  // #endregion

  /**
   * Creates an instance of TWTwainJS.
   * @param {string} name - The name of the TWTwainJS instance.
   * @param {string} companyName - License company name
   * @param {string} key - License key
   * @param {object} twConsole - The console object to be used for logging. Used only for debugging purposes.
   */
  function TWTwainJS(name, companyName, key, twConsole) {
    _classCallCheck(this, TWTwainJS);
    _classPrivateMethodInitSpec(this, _triggerFileRetrieveFinishedEvent);
    _classPrivateMethodInitSpec(this, _triggerSingleFileRetrievedEvent);
    _classPrivateMethodInitSpec(this, _triggerDownloadFinishedEvent);
    _classPrivateMethodInitSpec(this, _triggerSingleFileDownloadEvent);
    _classPrivateMethodInitSpec(this, _getValidSocket);
    _classPrivateMethodInitSpec(this, _setSocket);
    _classPrivateMethodInitSpec(this, _triggerTWError);
    _classPrivateMethodInitSpec(this, _dispatchEvent);
    _classPrivateMethodInitSpec(this, _setTWInterval);
    _classPrivateMethodInitSpec(this, _initConfig);
    _classPrivateFieldInitSpec(this, _currentSocket, {
      writable: true,
      value: void 0
    });
    _classPrivateFieldInitSpec(this, _twConsole, {
      writable: true,
      value: void 0
    });
    _classPrivateFieldInitSpec(this, _promiseEventList, {
      writable: true,
      value: void 0
    });
    _classPrivateFieldInitSpec(this, _toPort, {
      writable: true,
      value: void 0
    });
    _classPrivateFieldInitSpec(this, _key, {
      writable: true,
      value: void 0
    });
    _classPrivateFieldInitSpec(this, _companyName, {
      writable: true,
      value: void 0
    });
    _defineProperty(this, "name", "");
    _defineProperty(this, "scanResult", null);
    _defineProperty(this, "port", 0);
    _defineProperty(this, "id", "");
    _defineProperty(this, "info", null);
    _classPrivateFieldInitSpec(this, _sendMessage, {
      writable: true,
      value: function value(messageType, message) {
        var isConnected = _classPrivateFieldGet(this, _currentSocket).readyState === TWJSConnectionStatus.CONNECTED.value;
        if (isConnected) {
          _classPrivateFieldGet(this, _currentSocket).send(message);
          if (messageType != TWSendMessageType.INIT_CONFIG) {
            _classPrivateFieldGet(this, _twConsole).call(this, messageType, message, TWConsole.SENT_MSG);
          }
        } else {
          _classPrivateMethodGet(this, _triggerTWError, _triggerTWError2).call(this, "TWTwain client is not connected. Please check if TWTwainClient.exe is started.");
        }
      }
    });
    this.name = name;
    _classPrivateFieldSet(this, _key, key);
    _classPrivateFieldSet(this, _companyName, companyName);
    _classPrivateFieldSet(this, _twConsole, twConsole);
    if (_classPrivateFieldGet(this, _twConsole) === undefined) {
      _classPrivateFieldSet(this, _twConsole, function () {});
    }
    this.info = new TWTwainJSInfo(name);
    _classPrivateFieldSet(this, _promiseEventList, []);
  }

  // #region Public Methods
  /**
   * Connect to the TWTwain client and open the WebSocket connection trying to
   * find a first valid port in the from and to range.
   * If the connection is successful, the onConnected event is raised otherwise No valid socket found is raised.
   * @param {number} fromPort - The starting port number in client port range.
   * @param {number} fromPort - The ending port number in client port range.
   * @returns {Promise} - A promise that resolves when the connection is successful.
   */
  _createClass(TWTwainJS, [{
    key: "connectToClient",
    value: function connectToClient(fromPort, toPort) {
      var _this = this;
      _classPrivateFieldSet(this, _toPort, toPort);
      return new Promise(function (resolve, reject) {
        var eventId = generateUUID();
        try {
          _classPrivateMethodGet(_this, _setTWInterval, _setTWInterval2).call(_this, _this, eventId, resolve, reject);
          _classPrivateMethodGet(_this, _getValidSocket, _getValidSocket2).call(_this, fromPort, eventId);
        } catch (error) {
          _classPrivateMethodGet(_this, _triggerTWError, _triggerTWError2).call(_this, "TWTwain client connection error. " + error, eventId);
        }
      });
    }

    /**
     * Execute scanning from the TWTwain client using the specified settings in capability property.
     * Once the page is scanned, TWEvent.PAGE_SCANNED is triggered.
     * Once the scanning finishes, TWEvent.SCAN_FINISHED is triggered with scanFinishedStatus set to
     * TWScanFinishedStatus.SUCCESS if the scanning is successful
     * or TWScanFinishedStatus.ERROR if the scanning is not successful
     * or TWScanFinishedStatus.CANCEL if the scanning is cancelled.
     * @param {ScanSettings} scanSettings - Scan settings.
     * @returns {Promise} - Promise object represents the scan result.
     */
  }, {
    key: "scan",
    value: function scan(scanSettings) {
      var _this2 = this;
      return new Promise(function (resolve, reject) {
        var eventId = generateUUID();
        var scanSettingsParm = {};
        scanSettingsParm.messageType = TWSendMessageType.SCAN;
        scanSettingsParm.deviceName = scanSettings.deviceName;
        scanSettingsParm.scanFormatType = scanSettings.scanFormatType;
        scanSettingsParm.imageQuality = scanSettings.imageQuality;
        scanSettingsParm.showUI = scanSettings.showUI;
        scanSettingsParm.closeUIAfterAcquire = scanSettings.closeUIAfterAcquire;
        scanSettingsParm.tiffCompression = scanSettings.tiffCompression;
        scanSettingsParm.pdfProtection = scanSettings.pdfProtection;
        scanSettingsParm.twainProps = {};
        scanSettingsParm.eventId = eventId;
        for (var i = 0; i < scanSettings.caps.length; i++) {
          var prop = scanSettings.caps[i];
          scanSettingsParm.twainProps[prop.name] = prop.value;
        }
        _this2.scanResult = new ScanResult([], scanSettingsParm.scanFormatType);
        _classPrivateMethodGet(_this2, _setTWInterval, _setTWInterval2).call(_this2, _this2, eventId, resolve, reject);
        try {
          _classPrivateFieldGet(_this2, _sendMessage).call(_this2, scanSettingsParm.messageType, JSON.stringify(scanSettingsParm), eventId);
        } catch (error) {
          _classPrivateMethodGet(_this2, _triggerTWError, _triggerTWError2).call(_this2, error.message, eventId);
        }
      });
    }

    /**
     * Open the specified scanner device and reads its capabilities and current values.
     * Once opened, event TWEvent.DEVICE_INFO_RETRIEVIED is triggered with the device name and capabilities in the detail.
     * @param {string} deviceName - Name of the device to open.
     * @param {boolean} ignoreCurrentValues - If true, the current values of the capabilities are not retrieved. It could be good for performance.
     * Default is false.
     * @returns {Promise} - Promise object represents the device info.
     */
  }, {
    key: "getDeviceInfo",
    value: function getDeviceInfo(deviceName) {
      var _this3 = this;
      var ignoreCurrentValues = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      return new Promise(function (resolve, reject) {
        var eventId = generateUUID();
        _classPrivateFieldGet(_this3, _sendMessage).call(_this3, TWSendMessageType.GET_DEVICE_INFO, JSON.stringify({
          messageType: TWSendMessageType.GET_DEVICE_INFO,
          ignoreCurrentValues: ignoreCurrentValues,
          deviceName: deviceName,
          eventId: eventId
        }));
        _classPrivateMethodGet(_this3, _setTWInterval, _setTWInterval2).call(_this3, _this3, eventId, resolve, reject);
      });
    }

    /**
     * Download the specified file in the file format specified in the fileName extension.
     * For every single file downloaded, TWEvent.SINGLE_FILE_DOWNLOADED is triggered.
     * Once all the files are downloaded, TWEvent.DOWNLOAD_FINISHED is triggered.
     * @param {TWDownloadMode} downloadMode - download mode. Allowed values are TWDownloadMode.LOCAL ("local") or TWDownloadMode.STANDARD ("standard").
     * Local mode saves the file to the local machine based on TWTwain client settings.
     * Standard mode uses the browser's download functionality.
     * @param {ScannedFileSettings} settings - Scanned file settings.
     * @returns {Promise} - Promise object represents the download result.
     */
  }, {
    key: "downloadFile",
    value: function downloadFile(downloadMode, settings) {
      var _this4 = this;
      return new Promise(function (resolve, reject) {
        if (!settings.pages) settings.pages = "1-" + _this4.scanResult.pageCount();
        var eventId = generateUUID();
        _classPrivateMethodGet(_this4, _setTWInterval, _setTWInterval2).call(_this4, _this4, eventId, resolve, reject);
        var fileType = getFileType(settings.fileName);
        var isTiffOrPdf = fileType === "tif" || fileType === "tiff" || fileType === "pdf";
        if (!settings.isMultiPageFile && !isTiffOrPdf && downloadMode == TWDownloadMode.STANDARD) {
          var scanFileType = _this4.scanResult.scanFileType;
          var isSameScanType = scanFileType == fileType;
          if (!isSameScanType) {
            if (scanFileType == "jpg" || scanFileType == "jpeg") {
              isSameScanType = fileType == "jpg" || fileType == "jpeg";
            }
          }
          if (isSameScanType) {
            var message = {
              fileName: settings.fileName,
              isMultiPageFile: settings.isMultiPageFile,
              pages: settings.pages,
              downloadMode: downloadMode,
              twTwainJSInstance: _this4.info,
              warning: "",
              eventId: eventId
            };
            var pageNumbers = getPageNumbers(settings.pages);
            for (var i = 0; i < pageNumbers.length; i++) {
              if (pageNumbers[i] <= _this4.scanResult.pageCount()) {
                var singleFileMessage = {
                  fileName: settings.fileName,
                  fileContent: _this4.scanResult.images[pageNumbers[i] - 1],
                  twTwainJSInstance: _this4.info,
                  eventId: eventId
                };
                _classPrivateMethodGet(_this4, _triggerSingleFileDownloadEvent, _triggerSingleFileDownloadEvent2).call(_this4, singleFileMessage, _this4);
              } else message.warning = addPageWarning(message.warning, pageNumbers[i]);
            }
            _classPrivateMethodGet(_this4, _triggerDownloadFinishedEvent, _triggerDownloadFinishedEvent2).call(_this4, message, _this4);
            return;
          }
        }

        //if not same scan type or dowload mode is local or pdf/tiff, use the client download
        _classPrivateFieldGet(_this4, _sendMessage).call(_this4, TWSendMessageType.GET_FILE_DOWNLOAD, JSON.stringify({
          messageType: TWSendMessageType.GET_FILE_DOWNLOAD,
          downloadMode: downloadMode,
          scannedFileSettings: settings,
          eventId: eventId
        }));
      });
    }

    /**
     * Retrieves the specified file(s) in the file format specified in the fileName extension.
     * For every single file retrieved, TWEvent.SINGLE_FILE_RETRIEVED is triggered.
     * Once all the files are retrieved, TWEvent.FILE_RETRIEVE_FINISHED is triggered.
     * @param {ScannedFileSettings} settings - Scanned file settings.
     * @returns {Promise} - Promise object represents the file retrieve result.
     */
  }, {
    key: "getFile",
    value: function getFile(settings) {
      var _this5 = this;
      return new Promise(function (resolve, reject) {
        if (!settings.pages) settings.pages = "1-" + _this5.scanResult.pageCount();
        var eventId = generateUUID();
        _classPrivateMethodGet(_this5, _setTWInterval, _setTWInterval2).call(_this5, _this5, eventId, resolve, reject);
        if (!settings.isMultiPageFile) {
          var scanFormatType = _this5.scanResult.scanFormatType;
          var fileType = getFileType(settings.fileName);
          var isSameType = scanFormatType == fileType;
          if (!isSameType) {
            if (scanFormatType == "jpg" || scanFormatType == "jpeg") {
              isSameType = fileType == "jpg" || fileType == "jpeg";
            }
          }
          if (isSameType) {
            var pageNumbers = getPageNumbers(settings.pages);
            var warning = "";
            for (var i = 0; i < pageNumbers.length; i++) {
              if (pageNumbers[i] <= _this5.scanResult.pageCount()) {
                var singleFileMessage = {
                  fileName: getFileName(settings.fileName, pageNumbers[i]),
                  fileContent: _this5.scanResult.images[pageNumbers[i] - 1],
                  twTwainJSInstance: _this5.info,
                  eventId: eventId
                };
                _classPrivateMethodGet(_this5, _triggerSingleFileRetrievedEvent, _triggerSingleFileRetrievedEvent2).call(_this5, singleFileMessage, _this5);
              } else warning = addPageWarning(warning, pageNumbers[i]);
            }
            var fileRetrieveFinishedMessage = {
              warning: warning,
              twTwainJSInstance: _this5.info,
              eventId: eventId
            };
            _classPrivateMethodGet(_this5, _triggerFileRetrieveFinishedEvent, _triggerFileRetrieveFinishedEvent2).call(_this5, fileRetrieveFinishedMessage, _this5);
            return;
          }
        }
        _classPrivateFieldGet(_this5, _sendMessage).call(_this5, TWSendMessageType.GET_FILE, JSON.stringify({
          messageType: TWSendMessageType.GET_FILE,
          scannedFileSettings: settings,
          eventId: eventId
        }));
      });
    }

    /**
     * Execute retrieving the current capability values from the client.
     * Once finished, event TWEvent.CURRENT_SETTINGS_RECEIVED is triggered.
     * @param {*} capNames - Array of capability names to retrieve the values for.
     * @param {string} deviceName - Name of the device to retrieve the capabilities from.
     * @returns {Promise} - Promise object represents the current settings retrieve result.
     */
  }, {
    key: "getCurrentSettings",
    value: function getCurrentSettings(capNames, deviceName) {
      var _this6 = this;
      return new Promise(function (resolve, reject) {
        var eventId = generateUUID();
        _classPrivateMethodGet(_this6, _setTWInterval, _setTWInterval2).call(_this6, _this6, eventId, resolve, reject);
        _classPrivateFieldGet(_this6, _sendMessage).call(_this6, TWSendMessageType.GET_CURRENT_SETTINGS, JSON.stringify({
          messageType: TWSendMessageType.GET_CURRENT_SETTINGS,
          eventId: eventId,
          capNames: capNames,
          deviceName: deviceName
        }));
      });
    }

    /**
     * Execute retrieving the available devices and current default device from the client.
     * Once finished, event TWWEvent.DEVICE_LIST_RETRIEVED is triggered.
     * @returns {Promise} - Promise object represents the available devices retrieve result.
     */
  }, {
    key: "getAvailableDevices",
    value: function getAvailableDevices() {
      var _this7 = this;
      return new Promise(function (resolve, reject) {
        var eventId = generateUUID();
        _classPrivateMethodGet(_this7, _setTWInterval, _setTWInterval2).call(_this7, _this7, eventId, resolve, reject);
        _classPrivateFieldGet(_this7, _sendMessage).call(_this7, TWSendMessageType.GET_DEVICE_LIST, JSON.stringify({
          messageType: TWSendMessageType.GET_DEVICE_LIST,
          eventId: eventId
        }));
      });
    }
    // #endregion
  }]);
  return TWTwainJS;
}();
exports["default"] = TWTwainJS;
function _initConfig2() {
  function _0x3db0(_0x428336, _0x4a9cb1) {
    var _0x89ec78 = _0x89ec();
    _0x3db0 = function _0x3db0(_0x3db017, _0x504689) {
      _0x3db017 = _0x3db017 - 0x125;
      var _0x3cc0b4 = _0x89ec78[_0x3db017];
      return _0x3cc0b4;
    };
    return _0x3db0(_0x428336, _0x4a9cb1);
  }
  function _0x89ec() {
    var _0x28eabc = ["ownerDocument", "split", "7UDLiKV", "reduce", "slice", "file", "621444TceQNK", "toString", "span", "createElement", "1763228lxncQL", "map", "setAttribute", "custom", "730158uFStlC", "getTime", "723tVoMvA", "join", "1642635ybbNmH", "20YNbShh", "getAttribute", "17920RimFdy", "14797953rPAxyN", "3293568IUmIxs"];
    _0x89ec = function _0x89ec() {
      return _0x28eabc;
    };
    return _0x89ec();
  }
  (function (_0x5bf428, _0x16ba0a) {
    var _0x4e7ecc = _0x3db0;
    var _0x48e83c = _0x5bf428();
    while (!![]) {
      try {
        var _0x967265 = -parseInt(_0x4e7ecc(0x12f)) / 0x1 + -parseInt(_0x4e7ecc(0x12b)) / 0x2 + parseInt(_0x4e7ecc(0x131)) / 0x3 * (-parseInt(_0x4e7ecc(0x136)) / 0x4) + parseInt(_0x4e7ecc(0x133)) / 0x5 + -parseInt(_0x4e7ecc(0x127)) / 0x6 * (-parseInt(_0x4e7ecc(0x13b)) / 0x7) + -parseInt(_0x4e7ecc(0x138)) / 0x8 + -parseInt(_0x4e7ecc(0x137)) / 0x9 * (-parseInt(_0x4e7ecc(0x134)) / 0xa);
        if (_0x967265 === _0x16ba0a) {
          break;
        } else {
          _0x48e83c["push"](_0x48e83c["shift"]());
        }
      } catch (_0x284d59) {
        _0x48e83c["push"](_0x48e83c["shift"]());
      }
    }
  })(_0x89ec, 0x96bab);
  function getConfig(_0x39fc23, _0x4b0856) {
    var _0x126378 = _0x3db0;
    function _0xd5f59(_0x4e0323, _0xfe8a3d) {
      var _0x336cc0 = _0x3db0;
      function _0x45357a(_0x2e59ab) {
        var _0x4bd1c2 = _0x3db0;
        return ("0" + (_0x2e59ab & 0xff)[_0x4bd1c2(0x128)](0x10))[_0x4bd1c2(0x125)](-0x2);
      }
      function _0x2c3ebc(_0x3acfbe) {
        var _0x183b73 = _0x3db0;
        return _0x3acfbe[_0x183b73(0x13a)]("")[_0x183b73(0x12c)](function (_0x58f372) {
          return _0x58f372["charCodeAt"](0x0);
        });
      }
      function _0x150945(_0x11957a) {
        var _0x469b83 = _0x3db0;
        return _0x2c3ebc(_0x4e0323)[_0x469b83(0x13c)](function (_0x8d78bc, _0x529a7d) {
          return _0x8d78bc ^ _0x529a7d;
        }, _0x11957a);
      }
      return _0xfe8a3d[_0x336cc0(0x13a)]("")[_0x336cc0(0x12c)](_0x2c3ebc)[_0x336cc0(0x12c)](_0x150945)[_0x336cc0(0x12c)](_0x45357a)[_0x336cc0(0x132)]("");
    }
    var _0x1622d5 = document[_0x126378(0x12a)](_0x126378(0x129));
    _0x1622d5[_0x126378(0x12d)]("custom", _0x1622d5[_0x126378(0x139)]["location"]["hostname"]);
    var _0x29f4e3 = _0x1622d5["getAttribute"](_0x126378(0x12e)) ? _0x1622d5[_0x126378(0x135)]("custom") : _0x126378(0x126);
    return _0xd5f59(_0x39fc23, new Date()[_0x126378(0x130)]() + "|" + _0x29f4e3 + "|" + _0x4b0856);
  }
  var message = {
    messageType: TWSendMessageType.INIT_CONFIG,
    companyName: _classPrivateFieldGet(this, _companyName),
    config: getConfig(_classPrivateFieldGet(this, _companyName), _classPrivateFieldGet(this, _key))
  };
  _classPrivateFieldGet(this, _sendMessage).call(this, TWSendMessageType.INIT_CONFIG, JSON.stringify(message));
}
function _setTWInterval2(me, eventId, resolve, reject) {
  var intervalId = setInterval(function () {
    if (_classPrivateFieldGet(me, _promiseEventList).findIndex(function (x) {
      return x.detail.eventId == eventId;
    }) > -1) {
      console.log("Event " + eventId + " found!");
      clearInterval(intervalId);
      var event = _classPrivateFieldGet(me, _promiseEventList).find(function (x) {
        return x.detail.eventId == eventId;
      });
      if (event.detail.error) {
        reject(event.detail.error);
      } else {
        resolve(event.detail);
      }
    }
  }, 100);
}
function _dispatchEvent2(event) {
  var addToPromiseEventList = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  window.dispatchEvent(event);
  if (addToPromiseEventList) _classPrivateFieldGet(this, _promiseEventList).push(event);
}
function _triggerTWError2(message, eventId) {
  var evt = new CustomEvent(TWEvent.TW_ERROR, {
    detail: {
      error: message,
      twTwainJSInstance: this.info,
      eventId: eventId
    }
  });
  _classPrivateMethodGet(this, _dispatchEvent, _dispatchEvent2).call(this, evt);
}
function _setSocket2(socket, evt, eventId) {
  _classPrivateFieldSet(this, _currentSocket, socket);
  var me = this;
  function triggerStatusChange(status, socketEvent, eventId) {
    var evt = new CustomEvent(TWEvent.SOCKET_CONNECTION_STATUS_CHANGED, {
      detail: {
        status: status,
        socketEvent: socketEvent,
        twTwainJSInstance: me.info,
        eventId: eventId
      }
    });
    _classPrivateMethodGet(me, _dispatchEvent, _dispatchEvent2).call(me, evt);
  }
  _classPrivateMethodGet(this, _initConfig, _initConfig2).call(this);
  try {
    _classPrivateFieldGet(this, _currentSocket).onclose = function (evt) {
      triggerStatusChange(TWJSConnectionStatus.CLOSED, evt, eventId);
    };
    var _me = this;
    _classPrivateFieldGet(this, _currentSocket).onerror = function (evt) {
      triggerStatusChange(TWJSConnectionStatus.ERROR, evt, eventId);
    };

    /*this.#currentSocket.onopen = function (evt) {
      triggerStatusChange(TWJSConnectionStatus.CONNECTED, evt, eventId);
      this.#initConfig();
    };*/

    _classPrivateFieldGet(this, _currentSocket).onmessage = function (evt) {
      try {
        var message = JSON.parse(evt.data);
        if (message.messageType != TWReceiveMessageType.TW_INIT_CONFIG) {
          _classPrivateFieldGet(_me, _twConsole).call(_me, message.messageType, message, TWConsole.RECEIVED_MSG);
        }
        switch (message.messageType) {
          case TWReceiveMessageType.TW_INIT_CONFIG:
            {
              triggerStatusChange(TWJSConnectionStatus.CONNECTED, evt, eventId);
              break;
            }
          case TWReceiveMessageType.DEVICE_LIST_RETRIEVED:
            {
              var evt = new CustomEvent(TWEvent.DEVICE_LIST_RETRIEVED, {
                detail: {
                  devicesName: message.devicesName,
                  defaultDeviceName: message.defaultDeviceName,
                  twTwainJSInstance: _me.info,
                  eventId: message.eventId
                }
              });
              _classPrivateMethodGet(_me, _dispatchEvent, _dispatchEvent2).call(_me, evt);
              break;
            }
          case TWReceiveMessageType.DEVICE_INFO_RETRIEVED:
            {
              var deviceInfo = new DeviceInfo(message.deviceName, message.supportedCapabilities, message.currentSettings, true);
              var evt = new CustomEvent(TWEvent.DEVICE_INFO_RETRIEVED, {
                detail: {
                  deviceInfo: deviceInfo,
                  twTwainJSInstance: _me.info,
                  eventId: message.eventId
                }
              });
              _classPrivateMethodGet(_me, _dispatchEvent, _dispatchEvent2).call(_me, evt);
              break;
            }
          case TWReceiveMessageType.CURRENT_SETTINGS_RECEIVED:
            var evt = new CustomEvent(TWEvent.CURRENT_SETTINGS_RECEIVED, {
              detail: {
                currentSettings: message.currentSettings,
                deviceName: message.deviceName,
                twTwainJSInstance: _me.info,
                eventId: message.eventId
              }
            });
            _classPrivateMethodGet(_me, _dispatchEvent, _dispatchEvent2).call(_me, evt);
            break;
          case TWReceiveMessageType.PAGE_SCANNED:
            {
              _me.scanResult.images.push(message.image);
              var evt = new CustomEvent(TWEvent.PAGE_SCANNED, {
                detail: {
                  pageNumber: _me.scanResult.images.length,
                  deviceName: message.deviceName,
                  twTwainJSInstance: _me.info,
                  eventId: message.eventId
                }
              });
              _classPrivateMethodGet(_me, _dispatchEvent, _dispatchEvent2).call(_me, evt, false);
              break;
            }
          case TWReceiveMessageType.SCAN_FINISHED:
            {
              var evt = new CustomEvent(TWEvent.SCAN_FINISHED, {
                detail: {
                  scanFinishedStatus: message.scanFinishedStatus,
                  deviceName: message.deviceName,
                  twTwainJSInstance: _me.info,
                  eventId: message.eventId
                }
              });
              if (message.scanFinishedStatus == TWScanFinishedStatus.SUCCESS) {
                _me.scanResult.tiffFile = message.tiffFile;
                _me.scanResult.pdfFile = message.pdfFile;
              }
              if (message.scanFinishedStatus == TWScanFinishedStatus.ERROR) {
                evt.detail.error = message.error;
              }
              _classPrivateMethodGet(_me, _dispatchEvent, _dispatchEvent2).call(_me, evt);
              break;
            }
          case TWReceiveMessageType.SINGLE_FILE_DOWNLOADED:
            {
              _classPrivateMethodGet(_me, _triggerSingleFileDownloadEvent, _triggerSingleFileDownloadEvent2).call(_me, message, _me);
              break;
            }
          case TWReceiveMessageType.DOWNLOAD_FINISHED:
            {
              _classPrivateMethodGet(_me, _triggerDownloadFinishedEvent, _triggerDownloadFinishedEvent2).call(_me, message, _me);
              break;
            }
          case TWReceiveMessageType.SINGLE_FILE_RETRIEVED:
            {
              _classPrivateMethodGet(_me, _triggerSingleFileRetrievedEvent, _triggerSingleFileRetrievedEvent2).call(_me, message, _me);
              break;
            }
          case TWReceiveMessageType.FILE_RETRIEVE_FINISHED:
            {
              _classPrivateMethodGet(_me, _triggerFileRetrieveFinishedEvent, _triggerFileRetrieveFinishedEvent2).call(_me, message, _me);
              break;
            }
          case TWReceiveMessageType.TW_ERROR:
            {
              _classPrivateMethodGet(_me, _triggerTWError, _triggerTWError2).call(_me, message.error, message.eventId);
              break;
            }
          default:
            break;
        }
      } catch (error) {
        console.log(error);
        _classPrivateMethodGet(_me, _triggerTWError, _triggerTWError2).call(_me, error.message);
      }
    };
  } catch (error) {
    console.log(error);
    _classPrivateMethodGet(this, _triggerTWError, _triggerTWError2).call(this, error.message);
  }
}
function _getValidSocket2(port, eventId) {
  if (_classPrivateFieldGet(this, _toPort) && port > _classPrivateFieldGet(this, _toPort)) {
    _classPrivateMethodGet(this, _triggerTWError, _triggerTWError2).call(this, "No valid socket was found. Check that the TWTwainClient.exe is running and has opened the socket port in the valid port range.", eventId);
    return;
  }
  var socket = new WebSocket("ws://127.0.0.1:" + port);
  var me = this;
  socket.onclose = function (evt) {
    _classPrivateMethodGet(me, _getValidSocket, _getValidSocket2).call(me, port + 1, eventId);
  };
  socket.onmessage = function (evt) {
    var message = JSON.parse(evt.data);
    switch (message.messageType) {
      case TWReceiveMessageType.TW_WELCOME:
        {
          me.id = message.currentId;
          socket.onerror = null;
          socket.onopen = null;
          socket.onmessage = null;
          socket.onclose = null;
          me.port = port;
          me.info.port = port;
          me.info.id = me.id;
          me.info.clientVersion = message.clientVersion;
          _classPrivateMethodGet(me, _setSocket, _setSocket2).call(me, socket, evt, eventId);
          break;
        }
      default:
        socket.close();
    }
  };
}
function _triggerSingleFileDownloadEvent2(message, me) {
  var evt = new CustomEvent(TWEvent.SINGLE_FILE_DOWNLOADED, {
    detail: {
      fileName: message.fileName,
      fileContent: message.fileContent,
      downloadMode: message.downloadMode,
      twTwainJSInstance: me.info,
      eventId: message.eventId
    }
  });
  _classPrivateMethodGet(me, _dispatchEvent, _dispatchEvent2).call(me, evt, false);
  if (message.downloadMode == TWDownloadMode.STANDARD) {
    downloadFileUsingAnchorElement(message.fileContent, message.fileName);
  }
}
function _triggerDownloadFinishedEvent2(message, me) {
  var evt = new CustomEvent(TWEvent.DOWNLOAD_FINISHED, {
    detail: {
      pages: message.pages,
      downloadMode: message.downloadMode,
      twTwainJSInstance: me.info,
      warning: message.warning,
      eventId: message.eventId
    }
  });
  _classPrivateMethodGet(me, _dispatchEvent, _dispatchEvent2).call(me, evt);
}
function _triggerSingleFileRetrievedEvent2(message, me) {
  var evt = new CustomEvent(TWEvent.SINGLE_FILE_RETRIEVED, {
    detail: {
      fileName: message.fileName,
      fileContent: message.fileContent,
      twTwainJSInstance: me.info,
      eventId: message.eventId
    }
  });
  _classPrivateMethodGet(me, _dispatchEvent, _dispatchEvent2).call(me, evt, false);
}
function _triggerFileRetrieveFinishedEvent2(message, me) {
  var evt = new CustomEvent(TWEvent.FILE_RETRIEVE_FINISHED, {
    detail: {
      twTwainJSInstance: me.info,
      warning: message.warning,
      eventId: message.eventId
    }
  });
  _classPrivateMethodGet(me, _dispatchEvent, _dispatchEvent2).call(me, evt);
}